/*
**  ComponentJS -- Component System for JavaScript <http://componentjs.com>
**  Copyright (c) 2009-2016 Ralf S. Engelschall <http://engelschall.com>
**
**  This Source Code Form is subject to the terms of the Mozilla Public
**  License (MPL), version 2.0. If a copy of the MPL was not distributed
**  with this file, You can obtain one at http://mozilla.org/MPL/2.0/.
*/
/*
 *  This is a graphical ComponentJS debugger which provides both a
 *  component tree visualization and a ComponentJS debug message
 *  console. As in a production environment one might not want to carry
 *  this functionality with the application, this functionality has to
 *  stay in a separate optional plugin, of course.
 */
/* global ComponentJS:false */
ComponentJS.plugin("debugger",function(a,b,c){/*
     *  minimum emulation of jQuery
     */
a.jq=function(b,d){var e=[];if(1===arguments.length&&"string"!=typeof b)e.push(b);else{"undefined"==typeof d&&(d=c.document);try{e=d.querySelectorAll(b)}catch(a){e=c.document}e=a.concat([],e)}return a.extend(e,a.jq_methods),e},a.jq_methods={ready:function(a){/*  not correct (because too complicated to
                emulate portably), but sufficient for now!  */
for(var b=0;b<this.length;b++)!function(b){var c=this[b];/* global setTimeout:false */
setTimeout(function(){a.call(c)},250)}(b)},bind:function(a,b){for(var c=0;c<this.length;c++)"function"==typeof this[c].addEventListener?this[c].addEventListener(a,b,!1):"function"==typeof this[c].attachEvent&&this[c].attachEvent("on"+a,b);return this},width:function(a){for(var b="undefined"!=typeof a?this:void 0,c=0;c<this.length;c++)"undefined"==typeof a?(b=this[c].offsetWidth,"undefined"==typeof b&&(b=this[c].innerWidth),"undefined"==typeof b&&(b=this[c].clientWidth)):this[c].style.width=a;return b},height:function(a){for(var b="undefined"!=typeof a?this:void 0,c=0;c<this.length;c++)"undefined"==typeof a?(b=this[c].offsetHeight,"undefined"==typeof b&&(b=this[c].innerHeight),"undefined"==typeof b&&(b=this[c].clientHeight)):this[c].style.height=a;return b},css:function(b,c){for(var d="undefined"!=typeof c?this:void 0,e=b.replace(/-([a-z])/g,function(a,b){return b.toUpperCase()}),f=0;f<this.length;f++)"undefined"==typeof c?d=this[f].style[e]:a.isIE()?this[f].style.cssText=b+":"+c+";":this[f].style[e]=c;return d},attr:function(a,b){for(var c="undefined"!=typeof b?this:void 0,d=0;d<this.length;d++)"undefined"==typeof b?c=this[d].getAttribute(a):this[d].setAttribute(a,b);return c},html:function(b){for(var c=0;c<this.length;c++)try{/*  direct approach (but does not work on all elements,
                        especially not on html, head and body, etc)  */
this[c].innerHTML=b}catch(f){/*  create an arbitrary element on which we can use innerHTML  */
var d=a.dbg.document.createElement("div");/*  remove all nodes from target node  */
for(/*  set innerHTML, but use an outer wrapper element
                        to ensure we have a single root element  */
d.innerHTML="<div>"+b+"</div>";this[c].firstChild;)this[c].removeChild(this[c].firstChild);/*  add all nodes in our <div><div>...</div></div> enclosure  */
for(var e=0;e<d.firstChild.childNodes.length;e++)this[c].appendChild(d.firstChild.childNodes[e])}return this},scrollTop:function(a){for(var b=0;b<this.length;b++)this[b].scrollTop=a;return this},get:function(a){return this[a]}},/*  create debugger view mask (markup and style)  */
a.dbg_view_mask=function(b){a.jq("html head",a.dbg.document).html("<title>"+b+"</title>"),a.jq("html body",a.dbg.document).html("<style type=\"text/css\">html, body {margin: 0px;padding: 0px;}.dbg {width: 100%;height: 100%;font-family: Helvetica, Arial, sans-serif;background-color: #e0e0e0;overflow: hidden;font-size: 9pt;}.dbg .header {width: 100%;height: 30px;background: #666666;background: -moz-linear-gradient(top,  #666666 0%, #333333 49%, #222222 51%, #000000 100%);background: -webkit-gradient(linear, left top, left bottom, color-stop(0%,#666666), color-stop(49%,#333333), color-stop(51%,#222222), color-stop(100%,#000000));background: -webkit-linear-gradient(top,  #666666 0%,#333333 49%,#222222 51%,#000000 100%);background: -o-linear-gradient(top,  #666666 0%,#333333 49%,#222222 51%,#000000 100%);background: -ms-linear-gradient(top,  #666666 0%,#333333 49%,#222222 51%,#000000 100%);background: linear-gradient(to bottom,  #666666 0%,#333333 49%,#222222 51%,#000000 100%);filter: progid:DXImageTransform.Microsoft.gradient( startColorstr='#666666', endColorstr='#000000',GradientType=0 );text-align: center;position: relative;}.dbg .header .text {position: relative;top: 6px;color: #ffffff;font-size: 12pt;font-weight: bold;}.dbg .viewer {position: relative;width: 100%;height: 50%;background: #d0d0d0;background: -moz-linear-gradient(top,  #d0d0d0 0%, #e8e8e8 50%, #d0d0d0 100%);background: -webkit-gradient(linear, left top, left bottom, color-stop(0%,#d0d0d0), color-stop(50%,#e8e8e8), color-stop(100%,#d0d0d0));background: -webkit-linear-gradient(top,  #d0d0d0 0%,#e8e8e8 50%,#d0d0d0 100%);background: -o-linear-gradient(top,  #d0d0d0 0%,#e8e8e8 50%,#d0d0d0 100%);background: -ms-linear-gradient(top,  #d0d0d0 0%,#e8e8e8 50%,#d0d0d0 100%);background: linear-gradient(to bottom,  #d0d0d0 0%,#e8e8e8 50%,#d0d0d0 100%);filter: progid:DXImageTransform.Microsoft.gradient( startColorstr='#d0d0d0', endColorstr='#d0d0d0',GradientType=0 );overflow: hidden;}.dbg .viewer canvas {position: absolute;top: 0px;left: 0px;}.dbg .status {width: 100%;height: 20px;background: #666666;background: -moz-linear-gradient(top,  #666666 0%, #333333 49%, #222222 51%, #000000 100%);background: -webkit-gradient(linear, left top, left bottom, color-stop(0%,#666666), color-stop(49%,#333333), color-stop(51%,#222222), color-stop(100%,#000000));background: -webkit-linear-gradient(top,  #666666 0%,#333333 49%,#222222 51%,#000000 100%);background: -o-linear-gradient(top,  #666666 0%,#333333 49%,#222222 51%,#000000 100%);background: -ms-linear-gradient(top,  #666666 0%,#333333 49%,#222222 51%,#000000 100%);background: linear-gradient(to bottom,  #666666 0%,#333333 49%,#222222 51%,#000000 100%);filter: progid:DXImageTransform.Microsoft.gradient( startColorstr='#666666', endColorstr='#000000',GradientType=0 );color: #f0f0f0;text-align: center;}.dbg .filter input {width: 100%;background: #eeeeee;border: none;padding: 2px 2px 3px 52px;}.dbg .status .text {position: relative;top: 3px;color: #ffffff;font-size: 9pt;}.dbg .console {width: 100%;height: 50%;background-color: #ffffff;color: #000000;overflow-y: scroll;font-size: 9pt;}.dbg .console .text {width: 100%;height: auto;}.dbg .console .text .line {border-collapse: collapse;width: 100%;border-bottom: 1px solid #e0e0e0;font-size: 9pt;}.dbg .console .text .num {width: 40px;background-color: #f0f0f0;text-align: right;}.dbg .console .text .msg {padding-left: 10px;}.dbg .console .text .msg .prefix {color: #999999;}.dbg .console .text .msg .context {font-weight: bold;}.dbg .console .text .msg .path {color: #003399;}.dbg .console .text .msg .state {font-style: italic;}.dbg .console .text .msg .arrow {color: #999999;}.dbg .console .text .msg .method {font-family: monospace;}.dbg .grabber {position: absolute; cursor: move; width: 100%;height: 20px;background-color: transparent;opacity: 0.5;z-index: 100;}.dbg .infobox {position: absolute;top: 0px;left: 0px;width: 100%;background-color: #ffffff;color: #000000;z-index: 200;display: none;}.dbg .infobox table {border-collapse: collapse;width: 100%;}.dbg .infobox table tr td {border-bottom: 1px solid #e0e0e0;}.dbg .infobox table tr td {font-size: 11pt;}.dbg .infobox table tr td.label {padding-left: 10px;background-color: #f0f0f0;color: #909090;vertical-align: top;width: 160px;}.dbg .infobox table tr td.value {padding-left: 10px;vertical-align: top;}.dbg .infobox table tr td.value span.none {color: #909090;font-style: italic;}.dbg .plus, .dbg .reset, .dbg .minus, .dbg .exporter {cursor: pointer; position: absolute; top: 4px; width: 10px; text-align: center; font-weight: bold; padding: 2px 8px 2px 8px; border-top: 1px solid #777777;border-left: 1px solid #777777;border-right: 1px solid #555555;border-bottom: 1px solid #555555;background: #666666;background: -moz-linear-gradient(top,  #666666 0%, #333333 49%, #222222 51%, #000000 100%);background: -webkit-gradient(linear, left top, left bottom, color-stop(0%,#666666), color-stop(49%,#333333), color-stop(51%,#222222), color-stop(100%,#000000));background: -webkit-linear-gradient(top,  #666666 0%,#333333 49%,#222222 51%,#000000 100%);background: -o-linear-gradient(top,  #666666 0%,#333333 49%,#222222 51%,#000000 100%);background: -ms-linear-gradient(top,  #666666 0%,#333333 49%,#222222 51%,#000000 100%);background: linear-gradient(to bottom,  #666666 0%,#333333 49%,#222222 51%,#000000 100%);filter: progid:DXImageTransform.Microsoft.gradient( startColorstr='#666666', endColorstr='#000000',GradientType=0 );color: #c0c0c0;z-index: 100;}.dbg .plus {right: 80px; }.dbg .reset {right: 110px; }.dbg .minus {right: 140px; }.dbg .exporter {right: 20px; font-weight: normal; width: auto;}</style><div class=\"dbg\">"+'<div class="header"><div class="text">'+b+'</div></div><div class="viewer"><canvas></canvas></div><div class="grabber"></div><div class="plus">+</div><div class="reset">0</div><div class="minus">-</div><div class="exporter">Export</div><div class="status"><div class="text"></div></div><div class="filter"><input type="text" placeholder="Filter messages - RegExp enabled"></div><div class="console"><div class="text"></div></div><div class="infobox"></div></div>')},/*  debugger console log  */
a.dbg_logline=0,a.dbg_logbook=[],/*  debugger filter value  */
a.dbg_filter="",/*  log message to debugger console  */
a.dbg_log=function(b){if(null!==a.dbg){var c=b;b=b.replace("&","&amp;").replace("<","&lt;").replace(">","&gt;").replace("\n","<br/>"),a.dbg_logline++,b=b.replace(/(DEBUG\[\d+\]: )([^:]+)/,'<span class="prefix">$1</span><span class="context">$2</span>'),b=b.replace(/(\s+)(\/[^:\s]*)/g,'$1<span class="path">$2</span>'),b=b.replace(/(\s+)(@[a-z]+)/g,'$1<span class="state">$2</span>'),b=b.replace(/((?:&lt;)?--\()([a-z]+)(\)--(?:&gt;)?)/g,'<span class="arrow">$1</span><span class="method">$2</span><span class="arrow">$3</span>'),a.dbg_logbook.push({logline:a.dbg_logline,msg:b,originalMsg:c}),a.dbg_state_invalidate("console"),a.dbg_update()}},a.dbg_logbook_render=function(){var b="",c=/^\/(.*)\/(.*)?$/gm.exec(a.dbg_filter),d=a.dbg_filter,e="";c&&c.length>=2&&(d=c[1]),c&&3===c.length&&(e=c[2]);var f=new RegExp(d,e);for(var g in a.dbg_logbook)if(a.isown(a.dbg_logbook,g)){var h=a.dbg_logbook[g];f.exec(h.originalMsg)&&(b='<table class="line"><tr><td class="num">'+h.logline+'.</td><td class="msg">'+h.msg+"</td></tr></table>"+b)}return b},/*  determine component information for infobox  */
a.dbg_infobox_content=function(c){var d,e,f,g="",h=function(a){a.sort();var b="";for(f in a)b+="<code>"+a[f]+"</code>, ";return b=b.replace(/, $/,""),""===b&&(b='<span class="none">none</span>'),b},i=function(a,b){return'<tr><td class="label">'+a+'</td><td class="value">'+b+"</td></tr>"};/*  name and path  */
d=c.name().replace(/</,"&lt;").replace(/>/,"&gt;"),g+=i("Name:","<b>"+d+"</b>"),g+=i("Path:","<code>"+c.path("/")+"</code>");/*  role markers  */
var j="";b.marked(c.obj(),"view")&&(j+="view, "),b.marked(c.obj(),"model")&&(j+="model, "),b.marked(c.obj(),"controller")&&(j+="controller, "),b.marked(c.obj(),"service")&&(j+="service, "),j=j.replace(/, $/,""),""===j&&(j='<span class="none">none</span>'),g+=i("Markers:",j),/*  state and guards  */
g+=i("State:","<code>"+c.state()+"</code>");var k="";for(e in c.__state_guards)a.isown(c.__state_guards,e)&&"number"==typeof c.__state_guards[e]&&0!==c.__state_guards[e]&&(k+="<code>"+e+"</code> ("+c.__state_guards[e]+"), ");k=k.replace(/, $/,""),""===k&&(k='<span class="none">none</span>'),g+=i("Guards:",k);/*  spools  */
var l="";for(d in c.__spool)a.isown(c.__spool,d)&&"undefined"!=typeof c.__spool[d]&&c.__spool[d].length>0&&(l+="<code>"+d+"</code> ("+c.__spool[d].length+"), ");l=l.replace(/, $/,""),""===l&&(l='<span class="none">none</span>'),g+=i("Spools:",l);/*  model values  */
var m=[];for(f in c.__config)if(a.isown(c.__config,f)&&f.match(/^ComponentJS:property:ComponentJS:model/)&&"object"==typeof c.__config[f])for(d in c.__config[f].data)a.isown(c.__config[f].data,d)&&m.push(d);g+=i("Model Values:",h(m));/*  sockets  */
var n=[];for(f in c.__config)a.isown(c.__config,f)&&f.match(/^ComponentJS:property:ComponentJS:socket:/)&&"object"==typeof c.__config[f]&&n.push(f.replace(/^ComponentJS:property:ComponentJS:socket:/,""));g+=i("Sockets:",h(n));/*  event subscriptions, service registrations and hooks  */
var o=[],p=[],q=[];for(f in c.__subscription)a.isown(c.__subscription,f)&&"object"==typeof c.__subscription[f]&&"string"==typeof c.__subscription[f].name&&(c.__subscription[f].name.match(/^ComponentJS:/)||o.push(c.__subscription[f].name),c.__subscription[f].name.match(/^ComponentJS:service:/)&&p.push(c.__subscription[f].name.replace(/^ComponentJS:service:/,"")),c.__subscription[f].name.match(/^ComponentJS:hook:/)&&q.push(c.__subscription[f].name.replace(/^ComponentJS:hook:/,"")));/*  finish and return table  */
return g+=i("Event Subscriptions:",h(o)),g+=i("Service Registrations:",h(p)),g+=i("Hook Points:",h(q)),g="<table>"+g+"</table>"},/*
     *  ComponentJS debugger window
     */
/*  debugger window  */
a.dbg=null,/*  debugger update state  */
a.dbg_state_invalid={components:!1,states:!1,requests:!1,console:!1},a.dbg_state_invalidate=function(b){a.dbg_state_invalid[b]=!0},/*  debugger canvas: natural tree direction flag  */
a.dbg_natural=!1,/*  try to determine whether we are running instrumented,
        i.e., whether the native Browser debugger is active/open  */
b.debug_instrumented=function(){/* precision: Firefox Firebug  */
return"undefined"!=typeof c&&c.console&&(c.console.firebug||c.outerHeight-c.innerHeight>120)},/*  try to determine whether Internet Explorer is used  */
a.isIE=function(){/* global navigator:false */
return"undefined"!=typeof navigator&&"Microsoft Internet Explorer"===navigator.appName&&navigator.userAgent.match(new RegExp("MSIE ([0-9]+[.0-9]*)"))},/*  debugger window API entry point  */
b.debug_window=function(){/*  determine parameters  */
var d=b.params("debugger",arguments,{enable:{pos:0,def:null},autoclose:{pos:1,def:!1},name:{pos:2,def:null},width:{def:800},height:{def:600},natural:{def:!1}});/*  dispatch according to requested operation  */
if(null===d.enable)/*  determine debugger state  */
return null!==a.dbg;if(d.enable){/*  enable debugger  */
if(/*  remember natural rendering flag  */
a.dbg_natural=d.natural,null===a.dbg){/*  determine (potentially application specific) title  */
var e="ComponentJS Debugger";null!==d.name&&(e+=" ("+d.name+")");/*  create external debugger window  */
var f=e,g="location=no,scrollbars=no,toolbars=no,menubar=no,status=no";g+=",width="+d.width+",height="+d.height,a.isIE()?f=f.replace(/[^a-zA-Z0-9_]/g,"_"):g+=",replace=yes",a.dbg=c.open("about:blank",f,g),a.isIE()&&(/*  IE does not support reuse flag, so close old instance and open a fresh one  */
a.dbg.close(),a.dbg=c.open("about:blank",f,g)),/*  initialize the window content (deferred to avoid problems)  */
/* global setTimeout:false */
setTimeout(a.hook("ComponentJS:plugin:debugger:settimeout:func","pass",function(){a.jq(a.dbg.document).ready(function(){/*  optionally automatically close debugger window with application window  */
d.autoclose&&a.jq(c).bind("beforeunload",function(){null!==a.dbg&&a.dbg.close()}),/*  generate view mask  */
a.dbg_view_mask(e),/*  window-based resize support  */
a.dbg_refresh(),a.jq(a.dbg).bind("resize",function(){a.dbg_refresh()}),/*  avoid text selections (which confuse the grabbing) [non cross-browser event!]  */
a.jq(".dbg",a.dbg.document).bind("selectstart",function(a){return a.preventDefault(),!1});/*  grabbing-based resize support  */
var b=!1,f=!1,g=-1,h=-1;a.jq(".dbg .grabber",a.dbg.document).bind("mousedown",function(c){b=!0,a.jq(".dbg .grabber",a.dbg.document).css("background-color","red"),c.preventDefault()}),a.jq(".dbg",a.dbg.document).bind("mousemove",function(c){if(b){var d=c.pageY;d<300&&(d=300);var e=a.jq(a.dbg).height();d>e-100&&(d=e-100),a.jq(".dbg .grabber",a.dbg.document).css("top",d),a.dbg_grabber_offset=d,c.preventDefault()}else if(f){g===-1&&(g=c.pageX),h===-1&&(h=c.pageY);var i=g-c.pageX,j=h-c.pageY;g=c.pageX,h=c.pageY,a.dbg_canvas_info.x+=i,a.dbg_canvas_info.y+=j,a.dbg_reposition()}}),a.jq(".dbg",a.dbg.document).bind("mouseup",function(c){b&&(a.jq(".dbg .grabber",a.dbg.document).css("background-color","transparent"),a.dbg_refresh(),b=!1,c.preventDefault())}),/*  canvas export functionality  */
a.jq(".dbg .exporter",a.dbg.document).bind("click",function(b){var d=a.jq(".dbg .viewer canvas",a.dbg.document).get(0);if("undefined"!=typeof d){var e=d.toDataURL("image/png");c.open(e)}return b.preventDefault(),!1});/*  canvas scroll and zoom functionality  */
var i=100,j=10;a.jq(".dbg .plus",a.dbg.document).bind("click",function(){a.dbg_canvas_info.w+=i,a.dbg_canvas_info.h+=i,a.dbg_refresh()}),a.jq(".dbg .minus",a.dbg.document).bind("click",function(){a.dbg_canvas_info.w-=i,a.dbg_canvas_info.h-=i,a.dbg_refresh()}),a.jq(".dbg .reset",a.dbg.document).bind("click",function(){a.dbg_canvas_info.w=a.dbg_canvas_info.wmin,a.dbg_canvas_info.h=a.dbg_canvas_info.hmin,a.dbg_refresh()}),a.jq(".dbg .viewer canvas",a.dbg.document).bind("mousedown",function(){f=!0,g=-1,h=-1}),a.jq(".dbg .viewer canvas",a.dbg.document).bind("mouseup",function(){f=!1}),a.jq(a.dbg.document).bind("keydown",function(b){43===b.keyCode||107===b.keyCode||187===b.keyCode?(/*  key "+" pressed  */
a.dbg_canvas_info.w+=i,a.dbg_canvas_info.h+=i,a.dbg_refresh()):45===b.keyCode||109===b.keyCode||189===b.keyCode?(/*  key "-" pressed  */
a.dbg_canvas_info.w-=i,a.dbg_canvas_info.h-=i,a.dbg_refresh()):48===b.keyCode?(/*  key "0" pressed  */
a.dbg_canvas_info.w=a.dbg_canvas_info.wmin,a.dbg_canvas_info.h=a.dbg_canvas_info.hmin,a.dbg_refresh()):37===b.keyCode?(/*  key LEFT pressed  */
a.dbg_canvas_info.x+=j,a.dbg_reposition()):38===b.keyCode?(/*  key UP pressed  */
a.dbg_canvas_info.y+=j,a.dbg_reposition()):39===b.keyCode?(/*  key RIGHT pressed  */
a.dbg_canvas_info.x-=j,a.dbg_reposition()):40===b.keyCode&&(/*  key DOWN pressed  */
a.dbg_canvas_info.y-=j,a.dbg_reposition())}),/*  filter handling  */
a.dbg_filter_timeout=null,a.jq(".dbg .filter input",a.dbg.document).bind("keydown",function(a){a.stopPropagation()}),a.jq(".dbg .filter input",a.dbg.document).bind("keyup",function(b){a.dbg_filter_timeout&&(c.clearTimeout(a.dbg_filter_timeout),a.dbg_filter_timeout=null),a.dbg_filter_timeout=c.setTimeout(function(){a.dbg_filter=b.target.value,a.dbg_update_once(),a.dbg_filter_timeout&&(c.clearTimeout(a.dbg_filter_timeout),a.dbg_filter_timeout=null)},1e3)})})}),500)}b.debug(3,"debugger enabled")}else/*  disable debugger  */
null!==a.dbg&&(b.debug(3,"debugger disabled"),a.dbg.close(),a.dbg=null)},/*
     *  ComponentJS debugger content rendering
     */
/*  the grabber offset  */
a.dbg_grabber_offset=-1,/*  the canvas size and position  */
a.dbg_canvas_info={x:0,y:0,w:-1,h:-1,wmin:-1,hmin:-1},/*  refresh the browser rendering  */
a.dbg_refresh=function(){/*  expand to viewport width/height  */
var b=a.jq(a.dbg).width(),c=a.jq(a.dbg).height();if(a.jq(".dbg",a.dbg.document).width(b).height(c),/*  initially determine reasonable grabber offset  */
a.jq(".dbg .grabber",a.dbg.document).height(a.jq(".dbg .status",a.dbg.document).height()),a.dbg_grabber_offset===-1){var d=c-a.jq(".dbg .header",a.dbg.document).height();a.dbg_grabber_offset=Math.floor(d/2)+a.jq(".dbg .header",a.dbg.document).height()}/*  calculate viewer and console sizes based on grabber offset  */
var e=a.dbg_grabber_offset-a.jq(".dbg .header",a.dbg.document).height(),f=c-a.dbg_grabber_offset-a.jq(".dbg .status",a.dbg.document).height();a.jq(".dbg .viewer",a.dbg.document).height(e),a.jq(".dbg .console",a.dbg.document).height(f-a.jq(".dbg .filter",a.dbg.document).height()),a.jq(".dbg .infobox",a.dbg.document).height(f),a.jq(".dbg .infobox",a.dbg.document).css("top",a.dbg_grabber_offset+a.jq(".dbg .status",a.dbg.document).height()),a.jq(".dbg .grabber",a.dbg.document).css("top",a.dbg_grabber_offset),/*  explicitly set the canvas size of the viewer  */
a.dbg_canvas_info.wmin=b,a.dbg_canvas_info.hmin=e,a.dbg_canvas_info.w<a.dbg_canvas_info.wmin&&(a.dbg_canvas_info.w=a.dbg_canvas_info.wmin),a.dbg_canvas_info.h<a.dbg_canvas_info.hmin&&(a.dbg_canvas_info.h=a.dbg_canvas_info.hmin),a.jq(".dbg .viewer canvas",a.dbg.document).height(a.dbg_canvas_info.h).attr("height",a.dbg_canvas_info.h).width(a.dbg_canvas_info.w).attr("width",a.dbg_canvas_info.w),a.dbg_reposition(),/*  trigger an initial update  */
a.dbg_update()},/*  refresh the canvas positioning  */
a.dbg_reposition=function(){a.dbg_canvas_info.x<0&&(a.dbg_canvas_info.x=0),a.dbg_canvas_info.x>a.dbg_canvas_info.w-a.dbg_canvas_info.wmin&&(a.dbg_canvas_info.x=a.dbg_canvas_info.w-a.dbg_canvas_info.wmin),a.dbg_canvas_info.y<0&&(a.dbg_canvas_info.y=0),a.dbg_canvas_info.y>a.dbg_canvas_info.h-a.dbg_canvas_info.hmin&&(a.dbg_canvas_info.y=a.dbg_canvas_info.h-a.dbg_canvas_info.hmin),a.jq(".dbg .viewer canvas",a.dbg.document).css("top",-a.dbg_canvas_info.y).css("left",-a.dbg_canvas_info.x)},/*  update the debugger rendering  */
a.dbg_timer=null,a.dbg_update=function(){null!==a.dbg&&null===a.dbg_timer&&(/* global setTimeout:false */
a.dbg_timer=setTimeout(a.hook("ComponentJS:plugin:debugger:settimeout:func","pass",function(){a.dbg_update_once(),a.dbg_timer=null}),250))},/*  update the debugger rendering  */
a.dbg_update_once=function(){/*  update component information  */
if(/*  update console information  */
a.dbg_state_invalid.console&&(a.jq(".dbg .console .text",a.dbg.document).html(a.dbg_logbook_render()),a.jq(".dbg .console",a.dbg.document).scrollTop(0),a.dbg_state_invalid.console=!0),a.dbg_state_invalid.components||a.dbg_state_invalid.requests||a.dbg_state_invalid.states){/*  walk the component tree to determine information about components  */
var c,d,e;/*  status update  */
if((a.dbg_state_invalid.components||a.dbg_state_invalid.states)&&(c=a.root.walk_down(function(b,c,d,e){if(e){for(var f=0,g=0,h=c.children(),i=0;i<h.length;i++)f+=a.annotation(h[i],"debugger_width"),g+=a.annotation(h[i],"debugger_total");0===g&&f++,g++,a.annotation(c,"debugger_width",f),a.annotation(c,"debugger_total",g)}else/*  on downward walking, annotate component with its depth level
                            and calculcate the maximum depth level at all  */
a.annotation(c,"debugger_depth",b),d=b>d?b:d;return d},1),d=a.annotation(a.root,"debugger_width"),e=a.annotation(a.root,"debugger_total")),a.dbg_state_invalid.components||a.dbg_state_invalid.requests){/*  determine pending state transition requests  */
var f=0;for(var g in a.state_requests)a.isown(a.state_requests,g)&&f++;/*  update status line  */
a.jq(".dbg .status .text",a.dbg.document).html("Created Components: <b>"+e+"</b>, Pending Transition Requests: <b>"+f+"</b>"),a.dbg_state_invalid.requests=!0}/*  viewer update  */
if(a.dbg_state_invalid.components||a.dbg_state_invalid.states){/*  ensure the canvas (already) exists  */
var h=a.jq(".dbg .viewer canvas",a.dbg.document).get(0);if("undefined"==typeof h)return;h=h.getContext("2d");/*  determine canvas width/height and calculate grid width/height and offset width/height  */
var i=a.jq(".dbg .viewer canvas",a.dbg.document).height()-20,j=a.jq(".dbg .viewer canvas",a.dbg.document).width()-20,k=Math.floor(j/d),l=Math.floor(i/(c+1)),m=Math.floor(k/8),n=Math.floor(l/4);/*  clear the canvas as we redraw everything  */
h.clearRect(0,0,j,i);/*  walk the component tree to draw each component (on upward steps only)  */
var o=a.dbg_natural;a.root.walk_down(function(c,d,e,f){if(f){/*  grab previously calculated information  */
var g,j,p,q,r=a.annotation(d,"debugger_depth"),s=a.annotation(d,"debugger_total");if(1===s)/*  CASE 1: leaf node  */
g=10+k*e++,j=o?i-l*r-l+10:l*r-10,p=k-m,q=l-n;else{/*  CASE 2: intermediate node  */
var t=d.children(),u=a.annotation(t[0],"debugger_x"),v=u;/* var maxy = miny; */
t.length>1&&(v=a.annotation(t[t.length-1],"debugger_x")),/*  calculate our information  */
g=u+Math.ceil((v-u)/2),j=o?i-l*r-l+10:l*r-10,p=k-m,q=l-n;/*  draw line from component to each child component  */
for(var w=0;w<t.length;w++){var x=a.annotation(t[w],"debugger_x"),y=a.annotation(t[w],"debugger_y"),z=a.annotation(t[w],"debugger_w");/* var child_h = _cs.annotation(children[i], "debugger_h"); */
h.strokeStyle="#888888",h.lineWidth=2,h.beginPath(),h.moveTo(g+Math.ceil(p/2),j+(o?0:q)),h.lineTo(g+Math.ceil(p/2),j+(o?-Math.ceil(n/2):q+Math.ceil(n/2))),h.lineTo(x+Math.ceil(z/2),j+(o?-Math.ceil(n/2):q+Math.ceil(n/2))),h.lineTo(x+Math.ceil(z/2),y+(o?q:0)),h.stroke()}}/*  determine type of component  */
var A="";b.marked(d.obj(),"view")&&(A+="V"),b.marked(d.obj(),"model")&&(A+="M"),b.marked(d.obj(),"controller")&&(A+="C"),b.marked(d.obj(),"service")&&(A+="S");/*  draw component background  */
var B,C,D,E;"V"===A?(B="#14426f",C="#ffffff",D="#2068b0",E="#adcef0"):"M"===A?(B="#6f5014",C="#ffffff",D="#9a6f1c",E="#e8c581"):"S"===A?(B="#e8e8e8",C="#000000",D="#ffffff",E="#666666"):(B="#444444",C="#ffffff",D="#777777",E="#cccccc"),h.save(),h.fillStyle=B,h.shadowColor="#888888",h.shadowBlur=6,h.shadowOffsetX=1,h.shadowOffsetY=1,h.fillRect(g,j,p,q),h.restore(),h.fillStyle=D,h.fillRect(g,j+q/2,p,q/2),/*  draw component state indicator bulp  */
h.save(),h.fillStyle=a.states[d.__state].color,h.shadowColor="#000000",h.shadowBlur=2,h.shadowOffsetX=0,h.shadowOffsetY=0,h.beginPath(),h.arc(g+p-q/4-1,j+3*(q/4),q/4-3,0,2*Math.PI,!0),h.closePath(),h.fill(),h.restore();/*  draw optional state guard indicator bulp  */
var F=!1;for(var G in d.__state_guards)if("number"==typeof d.__state_guards[G]&&0!==d.__state_guards[G]){F=!0;break}F&&(h.save(),h.fillStyle="#ff0000",h.shadowColor="#000000",h.shadowBlur=2,h.shadowOffsetX=0,h.shadowOffsetY=0,h.beginPath(),h.arc(g+p-2*(q/4)-1,j+3*(q/4),q/4-3,0,2*Math.PI,!0),h.closePath(),h.fill(),h.restore());/*  common text rendering  */
var H=function(a,b,c,d,e){h.fillStyle=b;var f=h.measureText(a);if(f.width>e)for(;""!==a;){if(f=h.measureText(a+"..."),f.width<=e){a+="...";break}a=a.substr(0,a.length-1)}h.fillText(a,c,d,e)},I=0;if(""!==A){h.font="bold "+q/2*.7+"px Helvetica, Arial, sans-serif",h.textBaseline="top";var J=h.measureText(A);H(A,E,g+p-J.width-4,j+2,J.width),I=J.width}/*  draw component information (name and state)  */
h.font=q/2*.7+"px Helvetica, Arial, sans-serif",h.textBaseline="top",H(d.name(),C,g+4,j+2,p-I-8),H(d.state(),E,g+4,j+q/2+2,p-q/2-8),/*  provide our information to the parent component  */
a.annotation(d,"debugger_x",g),a.annotation(d,"debugger_y",j),a.annotation(d,"debugger_w",p),a.annotation(d,"debugger_h",q)}/*  pass-through the global X position  */
return e},0);/*  determine component on infobox event  */
var p=function(b){var c=b.offsetX;"undefined"==typeof c&&(c=b.layerX),"undefined"==typeof c&&(c=b.clientX);var d=b.offsetY;"undefined"==typeof d&&(d=b.layerY),"undefined"==typeof d&&(d=b.clientY-a.jq(".dbg .header",a.dbg.document).height());var e=null;if(a.root.walk_down(function(b,f,g,h){if(h){var i=a.annotation(f,"debugger_x"),j=a.annotation(f,"debugger_y"),k=a.annotation(f,"debugger_w"),l=a.annotation(f,"debugger_h");i<=c&&c<=i+k&&j<=d&&d<=j+l&&(e=f)}},0),null!==e){var f=a.dbg_infobox_content(e);a.jq(".dbg .infobox",a.dbg.document).html(f),a.jq(".dbg .infobox",a.dbg.document).css("display","block")}},q=!1;a.jq(".dbg .viewer canvas",a.dbg.document).bind("mousedown",function(b){b.target===a.jq(".dbg .viewer canvas",a.dbg.document).get(0)&&(p(b),q=!0)}),a.jq(".dbg .viewer canvas",a.dbg.document).bind("mousemove",function(b){b.target===a.jq(".dbg .viewer canvas",a.dbg.document).get(0)&&q&&p(b)}),a.jq(".dbg .viewer canvas",a.dbg.document).bind("mouseup",function(b){b.target===a.jq(".dbg .viewer canvas",a.dbg.document).get(0)&&(a.jq(".dbg .infobox",a.dbg.document).css("display","none"),q=!1)})}a.dbg_state_invalid.components=!0,a.dbg_state_invalid.states=!0}},/*
     *  ComponentJS debugger hooking
     */
/*  hook into internal logging  */
a.latch("ComponentJS:log",function(b){var c=!1;return null!==a.dbg&&(a.dbg_log(b),c=!0),c}),/*  hook into state changes  */
a.latch("ComponentJS:state-change",function(){a.dbg_update()}),/*  hook into state invalidation  */
a.latch("ComponentJS:state-invalidate",function(b){a.dbg_state_invalidate(b)})});