/*
**  ComponentJS -- Component System for JavaScript <http://componentjs.com>
**  Copyright (c) 2009-2016 Ralf S. Engelschall <http://engelschall.com>
**
**  This Source Code Form is subject to the terms of the Mozilla Public
**  License (MPL), version 2.0. If a copy of the MPL was not distributed
**  with this file, You can obtain one at http://mozilla.org/MPL/2.0/.
*/
/*
 *  This is a ComponentJS plugin which integrates the awesome Vue
 *  library for view mask rendering and data binding. It is smart enough
 *  to accept intermixed jQuery objects. This plugin requires Vue, but
 *  jQuery is not directly required.
 */
/* global ComponentJS: false */
/* global Vue: false */
/* eslint no-unused-vars: 0 */
/* jshint unused: false */
/*  helper function for detecting jQuery object  */
var isjQuery=function(a){return"object"==typeof a&&"string"==typeof a.jquery&&null!==a.jquery.match(/^[0-9]+(?:\.[0-9]+)+$/)},isVue=function(a){return"object"==typeof a&&"boolean"==typeof a._isVue&&a._isVue===!0};/*  hook as a plugin into ComponentJS  */
ComponentJS.plugin("vue",function(a,b,c){/*  define the extra trait for components  */
var d=b.trait({protos:{/*  create a new Vue instance  */
vue:function(){/*  determine parameters  */
var c=this,d=b.params("vue",arguments,{options:{pos:0,req:{}},spool:{pos:1,def:null}});/*  prepare the HTML mask template  */
if("undefined"==typeof d.options.template)throw a.exception("vue","missing mandatory Vue template");if(isjQuery(d.options.template)&&(d.options.template=d.options.template.get(0)),"string"==typeof d.options.template){for(;;){var e=d.options.template.replace(/^\s*<!--.*?-->\s*/,"");if(d.options.template===e)break;d.options.template=e}d.options.template=d.options.template.replace(/^\s+/,"").replace(/\s+$/,"")}for(/*  iterate over all models towards the root component and find all model values  */
var f,g,h={},i=this;null!==i&&(f=i.property({name:"ComponentJS:model",returnowner:!0}),a.isdefined(f));){g=f.property("ComponentJS:model"),i=f.parent();/*  remember all model values  */
for(var j in g.data)h[j]=f}var k=Object.keys(h);if(0===k.length)throw a.exception("vue","no models values found at all");/*  prepare Vue options  */
"object"!=typeof d.options.data&&(d.options.data={}),"object"!=typeof d.options.computed&&(d.options.computed={}),"object"!=typeof d.options.methods&&(d.options.methods={});/*  the symbol prefix for ComponentJS trigger model values  */
var l="ComponentJS_trigger_";/*  provide Vue model entries for all ComponentJS model values  */
a.foreach(k,function(a){var e=a.replace(/[^a-zA-Z0-9_$]+/g,"_");e.match(/^event.+$/)?/*  ComponentJS event values are implemented as Vue methods  */
d.options.methods[e]=function(d){b(c).value(a,!e.match(/^eventRaw.+$/)||d)}:(/*  other ComponentJS values are implemented as Vue computed properties  */
d.options.data[l+e]=0,d.options.computed[e]={get:function(){/*  get the underlying ComponentJS value  */
/*  tell Vue that we are depending on our trigger value
                                    (so we can later force Vue to call us again instead of
                                    using the cached value we returned beforehand)  */
return void this[l+e],b(c).value(a)},set:function(d){/*  update the Vue trigger value to ensure that Vue
                                    is forced to update the cached value of the above getter  */
this[l+e]++,/*  set the underlying ComponentJS value  */
b(c).value(a,d)}})}),/*  hook into Vue instance life-cycle  */
d.options.beforeDestroy=function(){a.foreach(this.__ComponentJS.observers,function(a){b(c).unobserve(a)}),a.foreach(this.__ComponentJS.sockets,function(a){b(c).unsocket(a)})};/*  create Vue instance  */
var m=new Vue(d.options);/*  render into a still stand-alone DOM fragment  */
m.$mount(),/*  attach ComponentJS information to Vue instance  */
m.__ComponentJS={observers:[],sockets:[]},/*  provide observers for the ComponentJS model values  */
a.foreach(k,function(d){var e=d.replace(/[^a-zA-Z0-9_$]+/g,"_"),f=function(){/*  just update the Vue trigger value  */
m[l+e]++};a.foreach(["set","splice","delete"],function(a){var e=b(c).observe({name:d,op:a,func:f});m.__ComponentJS.observers.push(e)})});/*  automatically create ComponentJS sockets for all
                    Vue-referenced DOM elements which are named sockets  */
for(var n in m.$refs)!function(a,d){if(a.match(/^socket.*/)){var e=b(c).socket({name:"socket"===a?"default":a,ctx:d});m.__ComponentJS.sockets.push(e)}}(n,m.$refs[n]);/*  optionally spool Vue instance destruction  */
if(null!==d.spool){var o=a.spool_spec_parse(this,d.spool);o.comp.spool(o.name,this,function(a){a.$destroy()},m)}/*  return Vue model  */
return m},/*  destroy a Vue instance  */
unvue:function(c){/*  determine parameters  */
var d=b.params("unvue",arguments,{vm:{pos:0,req:null}});/*  sanity check parameter  */
if(!isVue(d.vm))throw a.exception("unvue","invalid Vue instance");/*  destroy Vue instance  */
d.vm.$destroy()},/*  override the original ComponentJS socket() API method  */
socket:function(){/*  determine parameters  */
var a=b.params("socket",arguments,{name:{def:"default"},scope:{def:null},ctx:{pos:0,req:!0},plug:{pos:1,def:null},/*  removed "req: true"  */
unplug:{pos:2,def:null},/*  removed "req: true"  */
spool:{def:null}});/*  pass-through execution to original/base method  */
/*  provide specialized socket "plug" functionality  */
/*  provide specialized socket "unplug" functionality  */
return null===a.plug&&(a.plug=function(a){/*  on-the-fly get the HTML element from jQuery/Vue object  */
isjQuery(a)?a=a.get(0):isVue(a)&&(a=a.$el),/*  append to the DOM tree (the jQuery or plain way)  */
isjQuery(this)?this.append(a):this.appendChild(a)}),null===a.unplug&&(a.unplug=function(a){/*  remove from the DOM tree (the jQuery way)  */
if(isjQuery(a))a.detach();else{/*  on-the-fly get the HTML element from Vue object  */
isVue(a)&&(a=a.$el);/*  remove from the DOM tree (the plain way)  */
var b=a.parentElement;null!==b&&b.removeChild(a)}}),this.base(a)}}});/*  mixin this trait to all components  */
a.latch("ComponentJS:bootstrap:comp:mixin",function(a){a.push(d)})});